using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class DungeonGenerator : MonoBehaviour
{
    public class Cell{
        public bool visited = false;
        public bool[] status = new bool[4];
    }

    public Vector2 size;
    public int startPos = 0;
    public GameObject room;
    public GameObject Goal;
    private Vector2 offset = new Vector2(6, 6);
    List<Cell> board;
     private Vector3 lastRoomPosition;

    // Start is called before the first frame update
    void Start()
    {
        MazeGenerator();
    }

    // Update is called once per frame
    void Update()
    {
        
    }

    void GenerateDungeon(){
        for(int i = 0; i < size.x;i++){
            for( int j = 0; j < size.y;j++){
                Cell currentCell = board[Mathf.FloorToInt( i + j * size.x)];
                if(currentCell.visited == true){
                    var newRoom = Instantiate(room, new Vector3(i*offset.x,0, -j * offset.y), Quaternion.identity, transform).GetComponent<RoomBehaviour>();
                    newRoom.UpdateRoom(currentCell.status);
                    newRoom.name = "Room :"+i+ "-"+j;
                    lastRoomPosition = newRoom.transform.position;
                }
          
            }
        }
       if(lastRoomPosition != null &&Goal!= null){
        Instantiate(Goal, new Vector3(lastRoomPosition.x , 1,lastRoomPosition.z) , Quaternion.identity, transform).GetComponent<RoomBehaviour>();
       }
    }
    void MazeGenerator(){
        board = new List<Cell>();
        for(int i =0; i < size.x; i++){
            for(int j=0; j < size.y; j++){
                board.Add(new Cell());
        }
    }
        int currentCell= startPos;

        Stack<int> path = new Stack<int>();

        int k = 0;

        while(k< 1000){
            k++;

            board[currentCell].visited = true;
            if(currentCell == board.Count -1){
                break;
            }

            List<int> neighbors = CheckNeighbors(currentCell);
            if(neighbors.Count == 0){
                if(path.Count == 0){
                    break;
                }else{
                    currentCell = path.Pop();
                }
            }else{
                path.Push(currentCell);
                int newCell = neighbors[Random.Range(0, neighbors.Count)];

                if(newCell > currentCell){
                    // right or down
                    if(newCell -1 == currentCell){
                        board[currentCell].status[2] = true;
                        currentCell = newCell;
                        board[currentCell].status[3] = true;
                    }else{
                        board[currentCell].status[1] = true;
                        currentCell = newCell;
                        board[currentCell].status[0] = true;
                    }
                }else{
                    // Left or up
                        if(newCell +1 == currentCell){
                        board[currentCell].status[3] = true;
                        currentCell = newCell;
                        board[currentCell].status[2] = true;
                    }else{
                        board[currentCell].status[0] = true;
                        currentCell = newCell;
                        board[currentCell].status[1] = true;
                    }
                }
            }
        }

        GenerateDungeon();
    }

    List<int> CheckNeighbors(int cell){
        List<int> neighbors = new List<int>();
        // check Up neighbor
        if(cell - size.x >=0 && !board[Mathf.FloorToInt(cell - size.x)].visited){
            neighbors.Add(Mathf.FloorToInt(cell - size.x));
        }

        // check Down neighbor
        if(cell + size.x < board.Count && !board[Mathf.FloorToInt(cell + size.x)].visited){
            neighbors.Add(Mathf.FloorToInt(cell + size.x));
        }
        // check right neighbor
        if((cell+1) % size.x !=0 && !board[Mathf.FloorToInt(cell +1)].visited){
            neighbors.Add(Mathf.FloorToInt(cell + 1));
        }        
        // check Left neighbor
           if(cell % size.x !=0 && !board[Mathf.FloorToInt(cell - 1)].visited){
            neighbors.Add(Mathf.FloorToInt(cell - 1));
        }       
        return neighbors;
    }
}
